> For the complete documentation index, see [llms.txt](https://developer.vario-software.de/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.vario-software.de/api-reference/tenant-app.md).

# Tenant App

Manage VARIO Cloud tenant apps via the REST API, including token issuance, refresh, permissions, installed apps, status, settings, and app domains.

Tenant applications

## POST /cmn/apps/{identifier}/token

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"TenantApp","description":"Tenant applications"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/apps/{identifier}/token":{"post":{"tags":["TenantApp"],"operationId":"issueInstalledAppToken","parameters":[{"name":"identifier","in":"path","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/node-api-AppTokenDto"}}}}}}}},"components":{"schemas":{"node-api-AppTokenDto":{"properties":{"appIdentifier":{"type":"string","format":"uuid","description":"App identification number."},"bearerToken":{"type":"string","description":"Bearer token for the companion app API."},"expiresIn":{"type":"integer","format":"int32","description":"Token expiry in seconds."},"issuedAt":{"type":"string","format":"date-time","description":"Token issued at."}}}}}}
```

## POST /cmn/apps/{identifier}/refresh-token

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"TenantApp","description":"Tenant applications"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/apps/{identifier}/refresh-token":{"post":{"tags":["TenantApp"],"operationId":"issueInstalledAppToken_1","parameters":[{"name":"identifier","in":"path","required":true,"schema":{"type":"string","format":"uuid"}}],"requestBody":{"content":{"text/plain":{"schema":{"type":"string"}}},"required":true},"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/node-api-AppTokenDto"}}}}}}}},"components":{"schemas":{"node-api-AppTokenDto":{"properties":{"appIdentifier":{"type":"string","format":"uuid","description":"App identification number."},"bearerToken":{"type":"string","description":"Bearer token for the companion app API."},"expiresIn":{"type":"integer","format":"int32","description":"Token expiry in seconds."},"issuedAt":{"type":"string","format":"date-time","description":"Token issued at."}}}}}}
```

## POST /cmn/apps/{identifier}/permitted-token

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"TenantApp","description":"Tenant applications"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/apps/{identifier}/permitted-token":{"post":{"tags":["TenantApp"],"operationId":"issueTokenByPermission","parameters":[{"name":"identifier","in":"path","required":true,"schema":{"type":"string","format":"uuid"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/node-api-PermittedTokenRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/node-api-AppTokenDto"}}}}}}}},"components":{"schemas":{"node-api-PermittedTokenRequest":{"properties":{"expiresAt":{"type":"string","format":"date-time","description":"Valid until (UTC timestamp)."},"permissions":{"type":"array","description":"Permissions","items":{"type":"string","description":"Permissions"}}}},"node-api-AppTokenDto":{"properties":{"appIdentifier":{"type":"string","format":"uuid","description":"App identification number."},"bearerToken":{"type":"string","description":"Bearer token for the companion app API."},"expiresIn":{"type":"integer","format":"int32","description":"Token expiry in seconds."},"issuedAt":{"type":"string","format":"date-time","description":"Token issued at."}}}}}}
```

## GET /cmn/apps/installed

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"TenantApp","description":"Tenant applications"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/apps/installed":{"get":{"tags":["TenantApp"],"operationId":"getInstalledApps","responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/node-api-InstalledAppDto"}}}}}}}}},"components":{"schemas":{"node-api-InstalledAppDto":{"properties":{"installedFrom":{"type":"integer","format":"int64","description":"User Id"},"installedAt":{"type":"string","format":"date-time","description":"Installation time."},"appManifest":{"$ref":"#/components/schemas/node-api-AppManifestBaseDto"},"active":{"type":"boolean","default":true,"description":"Active."},"status":{"type":"string","description":"Status.","enum":["ONLINE","OFFLINE_TOKEN_EXPIRED"]},"settings":{"$ref":"#/components/schemas/unknownservice-unknownmodule-JsonNode"},"appDomain":{"type":"string","description":"App domain (FQDN) for iFrame loading."}}},"node-api-AppManifestBaseDto":{"description":"Manifest","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"identifier":{"type":"string","format":"uuid","description":"Unique Identifier of this CompanionApp"},"label":{"type":"string","description":"label / short description"},"appVersion":{"type":"string","description":"the latest version of this app"},"privateApp":{"type":"boolean","default":true,"description":"is this a private app or published via the public app-store"},"description":{"type":"string","description":"long description"},"pcInstallationDeletionUrl":{"type":"string","description":"Webhook called if the customer uninstall the app from their installation"},"uiIntegrations":{"$ref":"#/components/schemas/node-unknownmodule-UiIntegrationsDto"},"requirements":{"$ref":"#/components/schemas/node-unknownmodule-RequirementsDto"},"authorizationVerbs":{"type":"array","description":"access rights this app needs","items":{"$ref":"#/components/schemas/node-unknownmodule-AuthorizationVerbDto"}},"active":{"type":"boolean","default":true,"description":"Whether the app is globally active."}}},"core-api-MetaInfo":{"description":"MetaInformations for this Object","properties":{"createdAt":{"type":"string","format":"date-time","description":"Created At Timestamp","readOnly":true},"createdFrom":{"type":"string","description":"TenantUser-Identifier of the creator","readOnly":true},"updatedAt":{"type":"string","format":"date-time","description":"Last Updated AT Timestamp","readOnly":true},"updatedFrom":{"type":"string","description":"TenantUser-Identifier of most recent updater","readOnly":true}}},"node-unknownmodule-UiIntegrationsDto":{"description":"configuration of ui integrations","properties":{"integrations":{"type":"array","description":"List of UI integrations","items":{"$ref":"#/components/schemas/node-unknownmodule-UiIntegrationDto"}}}},"node-unknownmodule-UiIntegrationDto":{"description":"List of UI integrations","properties":{"id":{"type":"string","description":"Integration ID"},"permissionKey":{"type":"string","description":"Permission key"},"pointOfIntegration":{"type":"string","description":"Integration point"},"msgKey":{"type":"string","description":"Message key"},"url":{"type":"string","description":"Integration URL"},"iconClass":{"type":"string","description":"Icon CSS class"},"contextAttribute":{"type":"object","additionalProperties":{"type":"object","description":"Context attributes"},"description":"Context attributes"}}},"node-unknownmodule-RequirementsDto":{"description":"requirements this app needs","properties":{"licenseKey":{"type":"string","description":"Single license key"},"licenseKeys":{"type":"array","description":"Multiple license keys","items":{"type":"string","description":"Multiple license keys"}},"permissions":{"type":"array","description":"Permissions list","items":{"$ref":"#/components/schemas/node-unknownmodule-RequirementsPermissionDto"}}}},"node-unknownmodule-RequirementsPermissionDto":{"description":"Permissions list","properties":{"resource":{"type":"string","description":"Resource name"},"verb":{"type":"string","description":"Permission verb"}}},"node-unknownmodule-AuthorizationVerbDto":{"description":"access rights this app needs","properties":{"verb":{"type":"string","description":"Authorization verb"},"description":{"type":"string","description":"Description"},"autoAppendable":{"type":"boolean","description":"Whether auto-appendable"}}},"unknownservice-unknownmodule-JsonNode":{"description":"Search dialog.","properties":{"empty":{"type":"boolean"},"array":{"type":"boolean"},"null":{"type":"boolean"},"object":{"type":"boolean"},"float":{"type":"boolean"},"missingNode":{"type":"boolean"},"valueNode":{"type":"boolean"},"container":{"type":"boolean"},"integralNumber":{"type":"boolean"},"binary":{"type":"boolean"},"nodeType":{"type":"string","enum":["ARRAY","BINARY","BOOLEAN","MISSING","NULL","NUMBER","OBJECT","POJO","STRING"]},"string":{"type":"boolean"},"pojo":{"type":"boolean"},"short":{"type":"boolean"},"int":{"type":"boolean"},"long":{"type":"boolean"},"double":{"type":"boolean"},"bigDecimal":{"type":"boolean"},"bigInteger":{"type":"boolean"},"textual":{"type":"boolean","deprecated":true},"boolean":{"type":"boolean"},"floatingPointNumber":{"type":"boolean"},"number":{"type":"boolean"},"embeddedValue":{"type":"boolean"}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developer.vario-software.de/api-reference/tenant-app.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
